diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/net.c
--- a/src/dep/net.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/net.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,6 @@
 /*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen,
  *                         Jan Breuer
@@ -37,6 +39,14 @@
  *
  */
 
+#ifdef __sun
+#include <net/if_arp.h>
+#include <signal.h>
+#include "sfxge_ioctl.h"
+#include <string.h>
+extern void catch_alarm(int sig);
+#endif /* __sun */
+
 #include "../ptpd.h"
 
 /* choose kernel-level nanoseconds or microseconds resolution on the client-side */
@@ -44,6 +54,27 @@
 #error kernel-level timestamps not detected
 #endif
 
+/* Function that wraps up call to send message */
+static int sendMessage(int sockfd, const void *buf, size_t length,
+                       const struct sockaddr *addr, socklen_t addrLen,
+                       const char *messageType)
+{
+  int rc = sendto(sockfd, buf, length, 0, addr, addrLen);
+
+  if (rc < 0) {
+    DBG("error sending %s message, errno %d\n", messageType, errno);
+    return errno;
+  }
+  
+  if (rc != length) {
+    DBG("error sending %s message, sent %d bytes, expected %d\n",
+        messageType, rc, length);
+    return EIO;
+  }
+  
+  return 0;
+}
+
 /**
  * shutdown the IPv4 multicast for specific address
  *
@@ -149,12 +180,11 @@
 	return TRUE;
 }
 
-
 /*Test if network layer is OK for PTP*/
 UInteger8 
 lookupCommunicationTechnology(UInteger8 communicationTechnology)
 {
-#if defined(linux)
+#if defined(linux) || defined(__sun)
 	switch (communicationTechnology) {
 	case ARPHRD_ETHER:
 	case ARPHRD_EETHER:
@@ -164,170 +194,456 @@
 	default:
 		break;
 	}
-#endif  /* defined(linux) */
+#endif  /* defined(linux) || defined (__sun)*/
 
 	return PTP_DEFAULT;
 }
 
+#if defined(__sun)
+/* Find the local network interfacei; For solaris use lifreq */
+UInteger32 
+findIface(Octet * ifaceName, UInteger8 * communicationTechnology,
+    Octet * uuid, NetPath * netPath)
+{
+
+ /* depends on linux specific ioctls (see 'netdevice' man page) */
+ int i, flags;
+ struct lifconf data;
+ struct lifreq device[IFCONF_LENGTH];
+ struct sockaddr_dl *sdl;
+
+
+  /* an interface specified */
+    if (ifaceName[0] != '\0') {
+    i = 0;
+    memcpy(device[i].lifr_name, ifaceName, IFACE_NAME_LENGTH);
+    sdl = (struct sockaddr_dl *)&device[i].lifr_addr;
+
+    if (ioctl(netPath->eventSock, SIOCGLIFHWADDR, &device[i]) < 0)
+      DBGV("failed to get hardware address\n");
+    else if ((*communicationTechnology = sdl->sdl_type) != 0x4)
+      DBGV("unsupported communication technology (%d)\n", *communicationTechnology);
+    else {
+      memcpy(uuid, sdl->sdl_data, PTP_UUID_LENGTH);
+      clockIdentity_display(uuid);
+      }
+
+  } else {
+    /* no iface specified */
+    /* get list of network interfaces */
+
+	data.lifc_family = AF_INET;
+	data.lifc_len = sizeof(device);
+	data.lifc_req = device;
+
+	memset(data.lifc_buf, 0, data.lifc_len);
+
+	flags = IFF_UP | IFF_RUNNING | IFF_MULTICAST;
+
+    if (ioctl(netPath->eventSock, SIOCGLIFCONF, &data) < 0) {
+      PERROR("failed query network interfaces");
+      return 0;
+    }
+    if (data.lifc_len >= sizeof(device))
+      DBG("device list may exceed allocated space\n");
+
+    /* search through interfaces */
+    for (i = 0; i < data.lifc_len / sizeof(device[0]); ++i) {
+
+    sdl = (struct sockaddr_dl *)&device[i].lifr_addr;
+
+      DBGV("%d %s %s\n", i, device[i].lifr_name,
+          inet_ntoa(((struct sockaddr_in *)
+          &device[i].lifr_addr)->sin_addr));
+
+      if (ioctl(netPath->eventSock, SIOCGLIFFLAGS, 
+		&device[i]) < 0)
+        DBGV("failed to get device flags\n");
+      else if ((device[i].lifr_flags & flags) != flags)
+        DBGV("does not meet requirements"
+            "(%08x, %08x)\n", device[i].lifr_flags,
+            flags);
+      else if (ioctl(netPath->eventSock, SIOCGLIFHWADDR, &device[i]) < 0)
+        DBGV("failed to get hardware address\n");
+      else if ((*communicationTechnology = sdl->sdl_type) != 0x4)
+        DBGV("unsupported communication technology (%d)\n", *communicationTechnology);
+      else {
+        DBGV("found interface (%s)\n", device[i].lifr_name);
+        memcpy(uuid, sdl->sdl_data, PTP_UUID_LENGTH);
+        clockIdentity_display(uuid);
+        memcpy(ifaceName, device[i].lifr_name, IFACE_NAME_LENGTH);
+        break;
+      }
+    }
+  }
+
+  if (ifaceName[0] == '\0') {
+    ERROR("failed to find a usable interface\n");
+    return 0;
+  }
+  if (ioctl(netPath->eventSock, SIOCGLIFADDR, &device[i]) < 0) {
+    PERROR("failed to get ip address");
+    return 0;
+  }
+
+  /* @ioctl_timestamping Added support for IOCTL based timestamping for older kernels */
+  netPath->eventSockIFR = device[i];
+  return ((struct sockaddr_in *)&device[i].lifr_addr)->sin_addr.s_addr;
+}
+
+#else /* __sun */
 
  /* Find the local network interface */
 UInteger32 
 findIface(Octet * ifaceName, UInteger8 * communicationTechnology,
     Octet * uuid, NetPath * netPath)
 {
-#if defined(linux)
+#if defined(linux) || defined(__sun)
 
-	/* depends on linux specific ioctls (see 'netdevice' man page) */
-	int i, flags;
-	struct ifconf data;
-	struct ifreq device[IFCONF_LENGTH];
+        /* depends on linux specific ioctls (see 'netdevice' man page) */
+        int i, flags;
+        struct ifconf data;
+        struct ifreq device[IFCONF_LENGTH];
 
-	data.ifc_len = sizeof(device);
-	data.ifc_req = device;
+        data.ifc_len = sizeof(device);
+        data.ifc_req = device;
 
-	memset(data.ifc_buf, 0, data.ifc_len);
+  memset(data.ifc_buf, 0, data.ifc_len);
 
-	flags = IFF_UP | IFF_RUNNING | IFF_MULTICAST;
+  flags = IFF_UP | IFF_RUNNING | IFF_MULTICAST;
 
-	/* look for an interface if none specified */
-	if (ifaceName[0] != '\0') {
-		i = 0;
-		memcpy(device[i].ifr_name, ifaceName, IFACE_NAME_LENGTH);
+  /* an interface specified */
+  if (ifaceName[0] != '\0') {
+    i = 0;
+    memcpy(device[i].ifr_name, ifaceName, IFACE_NAME_LENGTH);
 
-		if (ioctl(netPath->eventSock, SIOCGIFHWADDR, &device[i]) < 0)
-			DBGV("failed to get hardware address\n");
-		else if ((*communicationTechnology = 
-			  lookupCommunicationTechnology(
-				  device[i].ifr_hwaddr.sa_family)) 
-			 == PTP_DEFAULT)
-			DBGV("unsupported communication technology (%d)\n", 
-			     *communicationTechnology);
-		else
-			memcpy(uuid, device[i].ifr_hwaddr.sa_data, 
-			       PTP_UUID_LENGTH);
-	} else {
-		/* no iface specified */
-		/* get list of network interfaces */
-		if (ioctl(netPath->eventSock, SIOCGIFCONF, &data) < 0) {
-			PERROR("failed query network interfaces");
-			return 0;
-		}
-		if (data.ifc_len >= sizeof(device))
-			DBG("device list may exceed allocated space\n");
+    if (ioctl(netPath->eventSock, SIOCGIFHWADDR, &device[i]) < 0)
+      DBGV("failed to get hardware address\n");
+    else if ((*communicationTechnology =
+        lookupCommunicationTechnology(
+          device[i].ifr_hwaddr.sa_family)) == PTP_DEFAULT)
+      DBGV("unsupported communication technology1 (%d)\n",
+          *communicationTechnology);
+    else
+      memcpy(uuid, device[i].ifr_hwaddr.sa_data, PTP_UUID_LENGTH);
 
-		/* search through interfaces */
-		for (i = 0; i < data.ifc_len / sizeof(device[0]); ++i) {
-			DBGV("%d %s %s\n", i, device[i].ifr_name, 
-			     inet_ntoa(((struct sockaddr_in *)
-					&device[i].ifr_addr)->sin_addr));
+  } else {
+    /* no iface specified */
+    /* get list of network interfaces */
+    if (ioctl(netPath->eventSock, SIOCGIFCONF, &data) < 0) {
+      PERROR("failed query network interfaces");
+      return 0;
+    }
+    if (data.ifc_len >= sizeof(device))
+      DBG("device list may exceed allocated space\n");
 
-			if (ioctl(netPath->eventSock, SIOCGIFFLAGS, 
-				  &device[i]) < 0)
-				DBGV("failed to get device flags\n");
-			else if ((device[i].ifr_flags & flags) != flags)
-				DBGV("does not meet requirements"
-				     "(%08x, %08x)\n", device[i].ifr_flags, 
-				     flags);
-			else if (ioctl(netPath->eventSock, SIOCGIFHWADDR, 
-				       &device[i]) < 0)
-				DBGV("failed to get hardware address\n");
-			else if ((*communicationTechnology = 
-				  lookupCommunicationTechnology(
-					  device[i].ifr_hwaddr.sa_family)) 
-				 == PTP_DEFAULT)
-				DBGV("unsupported communication technology"
-				     "(%d)\n", *communicationTechnology);
-			else {
-				DBGV("found interface (%s)\n", 
-				     device[i].ifr_name);
-				memcpy(uuid, device[i].ifr_hwaddr.sa_data, 
-				       PTP_UUID_LENGTH);
-				memcpy(ifaceName, device[i].ifr_name, 
-				       IFACE_NAME_LENGTH);
-				break;
-			}
-		}
-	}
+    /* search through interfaces */
+    for (i = 0; i < data.ifc_len / sizeof(device[0]); ++i) {
+      DBGV("%d %s %s\n", i, device[i].ifr_name,
+          inet_ntoa(((struct sockaddr_in *)
+          &device[i].ifr_addr)->sin_addr));
 
-	if (ifaceName[0] == '\0') {
-		ERROR("failed to find a usable interface\n");
-		return 0;
-	}
-	if (ioctl(netPath->eventSock, SIOCGIFADDR, &device[i]) < 0) {
-		PERROR("failed to get ip address");
-		return 0;
-	}
-	return ((struct sockaddr_in *)&device[i].ifr_addr)->sin_addr.s_addr;
+      if (ioctl(netPath->eventSock, SIOCGIFFLAGS, 
+		&device[i]) < 0)
+        DBGV("failed to get device flags\n");
+      else if ((device[i].ifr_flags & flags) != flags)
+        DBGV("does not meet requirements"
+            "(%08x, %08x)\n", device[i].ifr_flags,
+            flags);
+      else if (ioctl(netPath->eventSock, SIOCGIFHWADDR,
+              &device[i]) < 0)
+        DBGV("failed to get hardware address\n");
+      else if ((*communicationTechnology =
+          lookupCommunicationTechnology(
+            device[i].ifr_hwaddr.sa_family)) == PTP_DEFAULT)
+        DBGV("unsupported communication technology2"
+            "(%d)\n", *communicationTechnology);
+      else {
+        DBGV("found interface (%s)\n", 
+		device[i].ifr_name);
+        memcpy(uuid, device[i].ifr_hwaddr.sa_data, PTP_UUID_LENGTH);
+        memcpy(ifaceName, device[i].ifr_name, IFACE_NAME_LENGTH);
+        break;
+      }
+    }
+  }
+
+  if (ifaceName[0] == '\0') {
+    ERROR("failed to find a usable interface\n");
+    return 0;
+  }
+  if (ioctl(netPath->eventSock, SIOCGIFADDR, &device[i]) < 0) {
+    PERROR("failed to get ip address");
+    return 0;
+  }
+
+  /* @ioctl_timestamping Added support for IOCTL based timestamping for older kernels */
+  netPath->eventSockIFR = device[i];
+  return ((struct sockaddr_in *)&device[i].ifr_addr)->sin_addr.s_addr;
 
 #else /* usually *BSD */
 
-	struct ifaddrs *if_list, *ifv4, *ifh;
+  struct ifaddrs *if_list, *ifv4, *ifh;
 
-	if (getifaddrs(&if_list) < 0) {
-		PERROR("getifaddrs() failed");
-		return FALSE;
-	}
-	/* find an IPv4, multicast, UP interface, right name(if supplied) */
-	for (ifv4 = if_list; ifv4 != NULL; ifv4 = ifv4->ifa_next) {
-		if ((ifv4->ifa_flags & IFF_UP) == 0)
-			continue;
-		if ((ifv4->ifa_flags & IFF_RUNNING) == 0)
-			continue;
-		if ((ifv4->ifa_flags & IFF_LOOPBACK))
-			continue;
-		if ((ifv4->ifa_flags & IFF_MULTICAST) == 0)
-			continue;
-                /* must have IPv4 address */
-		if (ifv4->ifa_addr->sa_family != AF_INET)
-			continue;
-		if (ifaceName[0] && strncmp(ifv4->ifa_name, ifaceName, 
-					    IF_NAMESIZE) != 0)
-			continue;
-		break;
-	}
+  if (getifaddrs(&if_list) < 0) {
+    PERROR("getifaddrs() failed");
+    return FALSE;
+  }
+  /* find an IPv4, multicast, UP interface, right name(if supplied) */
+  for (ifv4 = if_list; ifv4 != NULL; ifv4 = ifv4->ifa_next) {
+    if ((ifv4->ifa_flags & IFF_UP) == 0)
+      continue;
+    if ((ifv4->ifa_flags & IFF_RUNNING) == 0)
+      continue;
+    if ((ifv4->ifa_flags & IFF_LOOPBACK))
+      continue;
+    if ((ifv4->ifa_flags & IFF_MULTICAST) == 0)
+      continue;
+    /* must have IPv4 address */
+    if (ifv4->ifa_addr->sa_family != AF_INET)
+      continue;
+    if (ifaceName[0] && strncmp(ifv4->ifa_name, ifaceName, 
+			    IF_NAMESIZE) != 0)
+      continue;
+    break;
+  }
 
-	if (ifv4 == NULL) {
-		if (ifaceName[0]) {
-			ERROR("interface \"%s\" does not exist,"
-			      "or is not appropriate\n", ifaceName);
-			return FALSE;
-		}
-		ERROR("no suitable interfaces found!");
-		return FALSE;
-	}
-	/* find the AF_LINK info associated with the chosen interface */
-	for (ifh = if_list; ifh != NULL; ifh = ifh->ifa_next) {
-		if (ifh->ifa_addr->sa_family != AF_LINK)
-			continue;
-		if (strncmp(ifv4->ifa_name, ifh->ifa_name, IF_NAMESIZE) == 0)
-			break;
-	}
+  if (ifv4 == NULL) {
+    if (ifaceName[0]) {
+      ERROR("interface \"%s\" does not exist,"
+            "or is not appropriate\n", ifaceName);
+      return FALSE;
+    }
+    ERROR("no suitable interfaces found!");
+    return FALSE;
+  }
+  /* find the AF_LINK info associated with the chosen interface */
+  for (ifh = if_list; ifh != NULL; ifh = ifh->ifa_next) {
+#ifndef __sun
+    if (ifh->ifa_addr->sa_family != AF_LINK)
+      continue;
+#endif
+    if (strncmp(ifv4->ifa_name, ifh->ifa_name, IF_NAMESIZE) == 0)
+      break;
+  }
 
-	if (ifh == NULL) {
-		ERROR("could not get hardware address for interface \"%s\"\n", 
-		      ifv4->ifa_name);
-		return FALSE;
-	}
-	/* check that the interface TYPE is OK */
-	if (((struct sockaddr_dl *)ifh->ifa_addr)->sdl_type != IFT_ETHER) {
-		ERROR("\"%s\" is not an ethernet interface!\n", ifh->ifa_name);
-		return FALSE;
-	}
-	DBG("==> %s %s %s\n", ifv4->ifa_name,
-	    inet_ntoa(((struct sockaddr_in *)ifv4->ifa_addr)->sin_addr),
-	    ether_ntoa((struct ether_addr *)
-		       LLADDR((struct sockaddr_dl *)ifh->ifa_addr))
-	    );
+  if (ifh == NULL) {
+    ERROR("could not get hardware address for interface \"%s\"\n",
+          ifv4->ifa_name);
+    return FALSE;
+  }
+  /* check that the interface TYPE is OK */
+  if (((struct sockaddr_dl *)ifh->ifa_addr)->sdl_type != IFT_ETHER) {
+    ERROR("\"%s\" is not an ethernet interface!\n", ifh->ifa_name);
+    return FALSE;
+  }
+  DBG("==> %s %s %s\n", ifv4->ifa_name,
+      inet_ntoa(((struct sockaddr_in *)ifv4->ifa_addr)->sin_addr),
+      ether_ntoa((struct ether_addr *)
+	      LLADDR((struct sockaddr_dl *)ifh->ifa_addr))
+      );
 
-	*communicationTechnology = PTP_ETHER;
-	memcpy(ifaceName, ifh->ifa_name, IFACE_NAME_LENGTH);
-	memcpy(uuid, LLADDR((struct sockaddr_dl *)ifh->ifa_addr), 
-	       PTP_UUID_LENGTH);
+  *communicationTechnology = PTP_ETHER;
+  memcpy(ifaceName, ifh->ifa_name, IFACE_NAME_LENGTH);
+  memcpy(uuid, LLADDR((struct sockaddr_dl *)ifh->ifa_addr), 
+	PTP_UUID_LENGTH);
 
-	return ((struct sockaddr_in *)ifv4->ifa_addr)->sin_addr.s_addr;
+  return ((struct sockaddr_in *)ifv4->ifa_addr)->sin_addr.s_addr;
 
 #endif
 }
+#endif /* __sun */
+
+/* @pdelay_req TODO timestamp is not being collected when PDELAY_REQ messages are */
+/* sent. Collect the timestamp and throw it away for now */
+static int txTimestamp(PtpClock *ptpClock, char *pdu, int pdulen, TimeMode timeMode, Boolean keep)
+{
+  TimeInternal ts;
+  int haveTs = 0;
+  int matchedPkt = 0;
+  NetPath *netPath = &ptpClock->netPath;
+
+  DUMP("PDU", pdu, pdulen);
+
+  switch (ptpClock->tsMethod) {
+    case TS_METHOD_SYSTEM:
+      /* Time stamp will appear on the multicast loopback. */
+      return 0;
+      break;
+
+    case TS_METHOD_DRIVER_IOCTL:
+      /* fast path: get send time stamp directly */
+      haveTs = getSendTime(&ts, timeMode, netPath);
+      if(haveTs) {
+        DBGV("got send time stamp in first attempt\n");
+      } else {
+        /*
+         * need to wait for it: need to check system time, counting
+         * the number of nanoSleep()s is too inaccurate because it
+         * each call sleeps much longer than requested
+         */
+        TimeInternal start, now;
+        timerNow(&start);
+        while(TRUE) {
+          TimeInternal delayAfterPacketSend;
+          delayAfterPacketSend.seconds = 0;
+          delayAfterPacketSend.nanoseconds = 1000;
+          nanoSleep(&delayAfterPacketSend);
+          haveTs = getSendTime(&ts, timeMode, netPath);
+          timerNow(&now);
+          subTime(&now, &now, &start);
+          /* 0.1 seconds is the maximum we wait... */
+          if(haveTs || now.seconds >= 1 || now.nanoseconds >= 100000000) {
+            DBGV("%s send time stamp after %d.%09ds\n",
+                 haveTs ? "got" : "failed to get",
+                 now.seconds, now.nanoseconds);
+            break;
+          }
+        }
+      }
+
+      if(haveTs) {
+        /* TODO can we match the packet in this case? */
+        matchedPkt = 1;
+      }
+      break;
+
+#ifndef  __sun /* Do not compile if __sun as we don't support non-ioctl method yet */
+    case TS_METHOD_SO_TIMESTAMPING:
+    {
+      struct cmsghdr *cmsg;
+      struct iovec vec[1];
+      struct msghdr msg;
+      struct sock_extended_err *err;
+      struct timespec *tmp;
+
+      int cnt, level, type;
+      char control[512];
+      unsigned char buf[PACKET_SIZE];
+      const char *ts_text;
+      
+      vec[0].iov_base = buf;
+      vec[0].iov_len = sizeof(buf);
+      memset(&msg, 0, sizeof(msg));
+      msg.msg_iov = vec;
+      msg.msg_iovlen = 1;
+      msg.msg_control = control;
+      msg.msg_controllen = sizeof(control);
+
+      /*
+       * need to wait for it: need to check system time, counting
+       * the number of nanoSleep()s is too inaccurate because it
+       * each call sleeps much longer than requested
+       */
+      TimeInternal start, now;
+      timerNow(&start);
+      while((cnt = recvmsg(netPath->eventSock, &msg, MSG_ERRQUEUE)) < 0) {
+        if ((errno == EAGAIN) || (errno == EINTR)) {
+          TimeInternal delay;
+          delay.seconds = 0;
+          delay.nanoseconds = 1000;
+          nanoSleep(&delay);
+          timerNow(&now);
+          subTime(&now, &now, &start);
+          /* 0.1 second is the maximum we wait... */
+          if(now.seconds >= 1 || now.nanoseconds >= 100000000) {
+            DBGV("Failed to get send time stamp after %d.%09ds\n",
+                 now.seconds, now.nanoseconds);
+            return -1;
+          }
+        } else {
+          ERROR("recvmsg failed: %s\n", strerror(errno));
+          return -1;
+        }
+      }
+
+      if (cnt < pdulen) {
+        ERROR("recvmsg returned only %d of %d bytes\n", cnt, pdulen);
+        return -1;
+      }
+
+      DUMP("cmsg all", buf, cnt);
+
+      for (cmsg = CMSG_FIRSTHDR(&msg); cmsg != NULL; cmsg = CMSG_NXTHDR(&msg, cmsg)) {
+
+        level = cmsg->cmsg_level;
+        type  = cmsg->cmsg_type;
+
+        DUMP("cmsg", cmsg, cmsg->cmsg_len);
+
+        if (SOL_SOCKET == level && SO_TIMESTAMPING == type) {
+          if (cmsg->cmsg_len < sizeof(*tmp)*3) {
+            ERROR("received short so_timestamping\n");
+            return -1;
+          }
+          /* array of three time stamps: software, HW, raw HW */
+          tmp = (struct timespec*)CMSG_DATA(cmsg);
+
+          switch (timeMode) {
+            case TIME_SYSTEM_LINUX_SW:
+              /* Desired timestamp is first in array */
+              ts_text = "SW SYS";
+              break;
+            case TIME_SYSTEM_LINUX_HW:
+              /* Desired timestamp is second in array */
+              ts_text = "HW SYS";
+              tmp++;
+            break;
+            case TIME_NIC:
+            case TIME_BOTH:
+              /* Desired timestamp is third in array */
+              ts_text = "HW RAW";
+              tmp += 2;
+              break;
+            default:
+              ERROR("Invalid case in switch %d\n", timeMode);
+              break;
+          }
+
+          if (tmp->tv_sec && tmp->tv_nsec) {
+            DBG("%s Tx TIMESTAMP: %d.%09d\n", ts_text, tmp->tv_sec, tmp->tv_nsec);
+            ts.seconds = tmp->tv_sec;
+            ts.nanoseconds = tmp->tv_nsec;
+            haveTs = 1;
+          }
+        } else if (IPPROTO_IP == level && IP_RECVERR == type) {
+          err = (struct sock_extended_err*)CMSG_DATA(cmsg);
+          if (err->ee_errno == ENOMSG &&
+              err->ee_origin == SO_EE_ORIGIN_TIMESTAMPING &&
+              !memcmp(pdu, buf + cnt - pdulen, pdulen)) {
+            matchedPkt = 1;
+          }
+        }
+      }
+    }
+      break;
+#endif /* ifndef __sun */
+
+    default:
+      ERROR("!!! txTimestamp() Unexpected time mode %d\n", timeMode);
+      return 0;
+      break;
+    }
+
+  if (!haveTs || !matchedPkt) {
+    return -1;
+  }
+
+  if (keep) {
+    /* Push packet onto stack. */
+    int index = netPath->tx_stack.count;
+    if (TX_STACK_SIZE == index) {
+      ERROR("out of stack space\n");
+      return -1;
+    }
+    memcpy(netPath->tx_stack.data[index].buf, pdu, pdulen);
+    netPath->tx_stack.data[index].len = pdulen;
+    netPath->tx_stack.data[index].ts = ts;
+    netPath->tx_stack.count++;
+  }
+
+  return 0;
+}
 
 /**
  * Init the multcast for specific IPv4 address
@@ -390,7 +706,7 @@
 
 
 	/* Init Peer multicast IP address */
-	memcpy(addrStr, PEER_PTP_DOMAIN_ADDRESS, NET_ADDRESS_LENGTH);
+	strncpy(addrStr, PEER_PTP_DOMAIN_ADDRESS, NET_ADDRESS_LENGTH);
 
 	if (!inet_aton(addrStr, &netAddr)) {
 		ERROR("failed to encode multi-cast address: %s\n", addrStr);
@@ -413,9 +729,9 @@
  * @return TRUE if successful
  */
 Boolean 
-netInitTimestamping(NetPath * netPath)
+netInitTimestamping(NetPath * netPath, Boolean useSystemTimeStamps)
 {
-	int val = 1;
+	int val = useSystemTimeStamps;
 	Boolean result = TRUE;
 	
 #if defined(SO_TIMESTAMPNS) /* Linux, Apple */
@@ -457,70 +773,76 @@
 
 /**
  * start all of the UDP stuff 
- * must specify 'subdomainName', and optionally 'ifaceName', 
+ * must specify 'subdomainName', and optionally 'ifaceName',
  * if not then pass ifaceName == "" 
- * on socket options, see the 'socket(7)' and 'ip' man pages 
+ * on socket options, see the 'socket(7)' and 'ip' man pages
  *
  * @param netPath 
- * @param rtOpts 
+ * @param rtOpts
  * @param ptpClock 
- * 
+ *
  * @return TRUE if successful
  */
-Boolean 
+Boolean
 netInit(NetPath * netPath, RunTimeOpts * rtOpts, PtpClock * ptpClock)
 {
-	int temp;
-	struct in_addr interfaceAddr, netAddr;
-	struct sockaddr_in addr;
+  int temp;
+#ifdef __sun
+  uchar_t temp_char;
+  char devpath[MAXLINKNAMELEN];
+#endif
 
-	DBG("netInit\n");
+  struct in_addr interfaceAddr, netAddr;
+  struct sockaddr_in addr;
+  Boolean useSystemTimeStamps = (rtOpts->time_mode == TIME_SYSTEM);
 
-	/* open sockets */
-	if ((netPath->eventSock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0
-	    || (netPath->generalSock = socket(PF_INET, SOCK_DGRAM, 
-					      IPPROTO_UDP)) < 0) {
-		PERROR("failed to initalize sockets");
-		return FALSE;
-	}
-	/* find a network interface */
-	if (!(interfaceAddr.s_addr = 
-	      findIface(rtOpts->ifaceName, 
-			&ptpClock->port_communication_technology,
-			ptpClock->port_uuid_field, netPath)))
-		return FALSE;
+  DBG("netInit\n");
 
-	/* save interface address for IGMP refresh */
-	netPath->interfaceAddr = interfaceAddr;
-	
-	DBG("Local IP address used : %s \n", inet_ntoa(interfaceAddr));
+  /* open sockets */
+  if ((netPath->eventSock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0
+      || (netPath->generalSock = socket(PF_INET, SOCK_DGRAM,
+		      IPPROTO_UDP)) < 0) {
+    PERROR("failed to initalize sockets");
+    return FALSE;
+  }
+  /* find a network interface */
+  if (!(interfaceAddr.s_addr =
+        findIface(rtOpts->ifaceName,
+      &ptpClock->port_communication_technology,
+      ptpClock->port_uuid_field, netPath)))
+    return FALSE;
 
-	temp = 1;			/* allow address reuse */
-	if (setsockopt(netPath->eventSock, SOL_SOCKET, SO_REUSEADDR, 
-		       &temp, sizeof(int)) < 0
-	    || setsockopt(netPath->generalSock, SOL_SOCKET, SO_REUSEADDR, 
-			  &temp, sizeof(int)) < 0) {
-		DBG("failed to set socket reuse\n");
-	}
-	/* bind sockets */
-	/*
-	 * need INADDR_ANY to allow receipt of multi-cast and uni-cast
-	 * messages
-	 */
-	addr.sin_family = AF_INET;
-	addr.sin_addr.s_addr = htonl(INADDR_ANY);
-	addr.sin_port = htons(PTP_EVENT_PORT);
-	if (bind(netPath->eventSock, (struct sockaddr *)&addr, 
-		 sizeof(struct sockaddr_in)) < 0) {
-		PERROR("failed to bind event socket");
-		return FALSE;
-	}
-	addr.sin_port = htons(PTP_GENERAL_PORT);
-	if (bind(netPath->generalSock, (struct sockaddr *)&addr, 
-		 sizeof(struct sockaddr_in)) < 0) {
-		PERROR("failed to bind general socket");
-		return FALSE;
-	}
+  /* save interface address for IGMP refresh */
+  netPath->interfaceAddr = interfaceAddr;
+
+  DBG("Local IP address used : %s \n", inet_ntoa(interfaceAddr));
+
+  temp = 1;			/* allow address reuse */
+  if (setsockopt(netPath->eventSock, SOL_SOCKET, SO_REUSEADDR,
+			  &temp, sizeof(int)) < 0
+      || setsockopt(netPath->generalSock, SOL_SOCKET, SO_REUSEADDR, 
+	      &temp, sizeof(int)) < 0) {
+    DBG("failed to set socket reuse\n");
+  }
+  /* bind sockets */
+  /*
+  * need INADDR_ANY to allow receipt of multi-cast and uni-cast
+  * messages
+  */
+  addr.sin_family = AF_INET;
+  addr.sin_addr.s_addr = htonl(INADDR_ANY);
+  addr.sin_port = htons(PTP_EVENT_PORT);
+  if (bind(netPath->eventSock, (struct sockaddr *)&addr,
+    sizeof(struct sockaddr_in)) < 0) {
+    PERROR("failed to bind event socket");
+    return FALSE;
+  }
+  addr.sin_port = htons(PTP_GENERAL_PORT);
+  if (bind(netPath->generalSock, (struct sockaddr *)&addr,
+    sizeof(struct sockaddr_in)) < 0) {
+    PERROR("failed to bind general socket");
+    return FALSE;
+  }
 
 
 
